﻿'Custom GUI's allow you to extend the look and behavior of blocks.
'
'You'll need to understand the "gui" class defined in GUIBase, which you'll inherit.  Custom GUI's are define by 
'code in this file and the XML file.  You can intereact with the block's parameters and the variables in end user
'12Block program.  You react to mouse events by first tracking mouse moves to set your "mode" and then using the "mode" to
'handle the click or drag.  Remember to call the "gui" class handlers for resizing...  12Blocks will set
'the "rect" and "values" arrays with your blocks location and variable values prior to calling the "draw" function.

Imports System.Windows.Forms, System.Drawing, GUIBase
Public Class exportGui
    Inherits gui
    Dim varlist, s, fstr, fname As String 'name of variable to monitor and change
    Dim t(20), tx, ty, old As Integer
    Public Sub New()
        sprites.init(2) 'background,foreground
        ReDim setpoints(2) 'x,y of text
        values("varlist") = 0
        name = "save"
        s = ""
        old = Integer.MinValue
    End Sub
    Public Overrides Function onMove(ByVal p As System.Drawing.Point) As moveres
        'If New Rectangle(tx, ty, myFont.Height, myFont.Height).Contains(p) Then Return New moveres(Cursors.IBeam, 1)
        Return MyBase.onMove(p)
    End Function
    Public Overrides Sub OnClick(ByVal p As Point)
        'If mode = 1 Then enterText(tx, ty, "value")
    End Sub
    Public Overrides Sub updateParameter(ByVal item As String, ByVal value As Object) 'draws the gui with provided values
        Select Case item
            Case "setpoints", "size", "position" : MyBase.updateParameter(item, value)
                tx = rect.X + rect.Width * setpoints(0)
                ty = rect.Y + rect.Height * setpoints(1)
            Case "varlist" : varlist = value : MyBase.updateParameter(item, value)
            Case "format" : fstr = value : MyBase.updateParameter(item, value)
            Case "file" : fname = value : MyBase.updateParameter(item, value)
            Case Else : MyBase.updateParameter(item, value)
        End Select
    End Sub
    Public Overrides Function updateDynamic() As Boolean
        
        Try
            Dim v() As String = Split(values("varlist"), ","c)

            If v(0) = old Then Return False
            old = v(0)
            s = String.Format(fstr, v)
            Dim objWriter As New System.IO.StreamWriter(fname, True)
            objWriter.WriteLine(s)
            objWriter.Close()
        Catch ex As Exception
            s = "Problem with format"
        End Try
        Return True
    End Function
    Public Overrides Function drawDynamic(ByVal g As System.Drawing.Graphics) As Boolean
        sprites.fillRectangle(g, 0, rect)
        g.DrawString(s, myFont, New SolidBrush(sprites.colorS(1)), tx, ty)
    End Function
End Class

'An textboxGui displays its variable's value and on a click, presents a textbox
Public Class textboxGui
    Inherits gui
    Dim var As String 'name of variable to monitor and change
    Dim v, tx, ty As Integer
    Public Sub New()
        sprites.init(2) 'background,foreground
        ReDim setpoints(2) 'x,y of text
        values("var") = 0 'variable to monitor/change
        name = "textbox"
    End Sub
    Public Overrides Function onMove(ByVal p As System.Drawing.Point) As moveres
        If New Rectangle(tx, ty, myFont.Height, myFont.Height).Contains(p) Then Return New moveres(Cursors.IBeam, 1)
        Return MyBase.onMove(p)
    End Function
    Public Overrides Sub OnClick(ByVal p As Point)
        If mode = 1 Then enterText(tx, ty, "value")
    End Sub
    Public Overrides Sub updateParameter(ByVal item As String, ByVal value As Object) 'draws the gui with provided values
        Select Case item
            Case "setpoints", "size", "position" : MyBase.updateParameter(item, value)
                tx = rect.X + rect.Width * setpoints(0)
                ty = rect.Y + rect.Height * setpoints(1)
            Case Else : MyBase.updateParameter(item, value)
        End Select
    End Sub
    Public Overrides Function updateDynamic() As Boolean
        If values("var") <> v Then v = values("var") : Return True
        Return False
    End Function
    Public Overrides Function drawDynamic(ByVal g As System.Drawing.Graphics) As Boolean
        sprites.fillRectangle(g, 0, rect)
        g.DrawString(v.ToString, myFont, New SolidBrush(sprites.colorS(1)), tx, ty)
    End Function
End Class
'A meterGUI graphs the value of its variable as a meter 
Public Class meterGUI
    Inherits gui
    Dim var As String 'name of variable to graph
    Dim mn, mx As Integer
    Dim meterx, meterw, metery, meterh As Integer
    Dim v As Integer
    Public Sub New()
        values("var") = 0 'value to graph
        sprites.init(3) 'static background, meter background, meter foreground
        ReDim setpoints(3) 'x,y of top-left meter. width,height of meter
        name = "meter"
    End Sub
    Public Overrides Sub updateParameter(ByVal item As String, ByVal value As Object)
        Select Case item
            Case "min" : mn = CInt(Val(CStr(value)))
            Case "max" : mx = CInt(Val(CStr(value)))
            Case "setpoints", "size", "position" : MyBase.updateParameter(item, value)
                meterx = rect.X + rect.Width * setpoints(0)
                metery = rect.Y + rect.Height * setpoints(1)
                meterw = rect.Width * setpoints(2)
                meterh = rect.Height * setpoints(3)
            Case Else : MyBase.updateParameter(item, value)
        End Select
    End Sub
    Public Overrides Function updateDynamic() As Boolean
        If values("var") <> v Then v = values("var") : Return True
        Return False
    End Function
    Public Overrides Sub drawStatic(ByVal g As System.Drawing.Graphics)
        sprites.fillRectangle(g, 0, rect)
        MyBase.drawStatic(g)
    End Sub
    Public Overrides Function drawDynamic(ByVal g As System.Drawing.Graphics) As Boolean
        Dim lev
        lev = CInt((Math.Min(Math.Max(v, mn), mx) - mn) / (mx - mn) * meterh)
        sprites.fillRectangle(g, 1, New Rectangle(meterx, metery + meterh - lev, meterw, lev))
        sprites.fillRectangle(g, 2, New Rectangle(meterx, metery, meterw, meterh - lev))
    End Function
End Class
'A switchGUI shows one of two sprites(0 and non-0). Click it to toggle its value
Public Class switchGUI
    Inherits gui
    Dim switch As Rectangle = New Rectangle()
    Dim var As String
    Dim v As Integer
    Public Sub New()
        values("var") = 0 'value to switch
        name = "switch"
        sprites.init(2) 'sprite to show for 0,sprite to show for non-0
    End Sub
    Public Overrides Function onMove(ByVal p As System.Drawing.Point) As moveres
        If switch.Contains(p) Then Return New moveres(Cursors.Arrow, 1)
        Return MyBase.onMove(p)
    End Function
    Public Overrides Sub OnClick(ByVal p As Point)
        If mode = 1 Then setVar("var", If(values("var") <> 0, "0", "1"))
    End Sub
    Public Overrides Function updateDynamic() As Boolean
        If values("var") <> v Then v = values("var") : Return True
        Return False
    End Function
    Public Overrides Function drawDynamic(ByVal g As System.Drawing.Graphics) As Boolean
        If sprites.imgS(0) IsNot Nothing Then
            g.DrawImage(sprites.imgS(If(v = 0, 0, 1)), rect)
            switch.X = rect.X + 5 : switch.Y = rect.Y + 5 : switch.Width = rect.Width - 10 : switch.Height = rect.Height - 10
        Else
            sprites.fillRectangle(g, 0, rect)
            switch.X = rect.X + 15 : switch.Y = rect.Y + 15 : switch.Width = rect.Width - 30 : switch.Height = rect.Height - 30
            g.DrawString(values(0).ToString, myFont, Brushes.White, rect.X + 10, rect.Y)
            sprites.fillRectangle(g, If(v = 0, 1, 2), switch)
        End If
    End Function
End Class
'A joystickGUI displays 2 variables in xy format.  Drag the "stick" to change the values
Public Class joystickGUI
    Inherits gui
    Dim varX, varY As String '2 variables to track
    Dim mn, mx As Integer
    Dim updt As Boolean
    Dim stick As Rectangle = New Rectangle(0, 0, 10, 10)
    Dim stickarea As Rectangle = New Rectangle(0, 0, 10, 10)
    Dim vx, vy As Integer
    Public Sub New()
        values("varx") = 0 : values("vary") = 0 'x,y of stick
        name = "joystick"
        sprites.init(2) 'background of joystick, and stick
        ReDim setpoints(6) 'x,y,width,height of stick area, width/heigh of stick
    End Sub
    Public Overrides Sub updateParameter(ByVal item As String, ByVal value As Object)
        Select Case item
            Case "min" : mn = str2int(value)
            Case "max" : mx = str2int(value)
            Case "setpoints", "size", "position"
                MyBase.updateParameter(item, value)
                If item = "setpoints" Then
                    sprites.ratioS(1).Width = setpoints(4)
                    sprites.ratioS(1).Height = setpoints(5)
                    sprites.update(rect)
                End If
                stick.Width = setpoints(4) * rect.Width
                stick.Height = setpoints(5) * rect.Height
                With stickarea
                    .X = rect.X + rect.Width * setpoints(0)
                    .Y = rect.Y + rect.Height * setpoints(1)
                    .Width = rect.Width * setpoints(2)
                    .Height = rect.Height * setpoints(3)
                End With

            Case Else : MyBase.updateParameter(item, value)
        End Select
    End Sub
    Public Overrides Function updateDynamic() As Boolean
        If False Then 'Not mode = 1 Then
            vx = (mx + mn) / 2 : vy = (mx + mn) / 2
            setVar("varx", vx)
            setVar("vary", vy) : Return True
        End If

        If values("varx") <> vx Or values("vary") <> vy Then vx = values("varx") : vy = values("vary") : Return True
        Return False
    End Function
    Public Overrides Function drawDynamic(ByVal g As System.Drawing.Graphics) As Boolean
        With stickarea
            stick.X = .X - stick.Width \ 2 + (Math.Max(Math.Min(vx, mx), mn) - mn) / (mx - mn) * .Width
            stick.Y = .Y - stick.Height \ 2 + (Math.Max(Math.Min(vy, mx), mn) - mn) / (mx - mn) * .Height
        End With
        sprites.fillRectangle(g, 0, rect)
        sprites.fillRectangle(g, 1, stick)
    End Function
    Public Overrides Function onMove(ByVal p As System.Drawing.Point) As moveres
        If stickarea.Contains(p) Then Return New moveres(Cursors.Cross, 900)
        Return MyBase.onMove(p)
    End Function
    Public Overrides Function onDrag(ByVal start As System.Drawing.Point, ByVal current As System.Drawing.Point) As System.Windows.Forms.Cursor
        If mode = 900 Then
            updt = True
            With stickarea
                setVar("varx", Math.Min(Math.Max(CInt((current.X - .X) / (.Width) * (mx - mn) + mn), mn), mx))
                setVar("vary", Math.Min(Math.Max(CInt((current.Y - .Y) / (.Height) * (mx - mn) + mn), mn), mx))
            End With
            Return Cursors.Cross
        End If
        Return MyBase.onDrag(start, current)
    End Function
End Class
