{<skip/>}
{****************************
* (C) 2010 onerobot.org     *
* Demo of xconduit          *
* AppletImage=scope.gif     *
*****************************
v.5 5-4: Uses rts correctly.  Streams to specified location in world array.
v.6 7-11: doesn't use other objects, loads program remotely, new mDbg command, stops cogs correctly


XConduit:
  Communication should allow:
  - sending a message and getting it's forced reply
  - streaming data into a shared memory
  - writing data to hub
  - executing commands like reboot, stopcogs, clear
  - commanding the remote bot to write data/stream/send a message
  - terminal emulation 
  Most of the complexity is managed by spin code which manages several arrays:
  - cmdList: communication request are placed here
  - cmdStatus: status for a communication request will be returned here 
  - mailbox: new mail from other bots is placed here
  - info: information from other bots is shared here
  Communication requests can be one of the following:  
  - write: write data to hub
  - send: send message to remote bot's mailbox.  Remote must send a "reply" which is placed in reply buffer 
  - reply: send reply to a "sent" message
  - reboot: reboot the remote bot
  - stopcogs: stop all cogs aside from xconduit cog to prevent hub from changing 
  - stream: continuously stream data from info to other bots'info without acknowledgement
  - addcmd: add a command to the remote bot's list
  - clear: clear command list on the remote bot
  - debug: sends a debug reply consisting of first bytes of hub
  - commands are stored: [mode4,addr4,ptr16,length8]
  Bots can communicate using a "Terminal"
  - Bots need to start a session with a bot and memory for the in/out queues
  - Once it has a session, data to output is added to the outq
  - The driver code will output the whole outq whenever it's not empty
  - Incoming data is added to the inq circular buffer.
  - cmd for cterminal is:[mode4,addr4,ptr16,outtail8]
  - status for cterminal is: [outhead8,inhead8,intail8,_]
  - terminal data is not acknowledged
}
con
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 6_000_000

  
  maxCmds=16 'max number of commands in buffer
  maxBots=16 'max number of bots
  lenInfo=12 'length of "world information" for each bot
  lenMail=10 'length of "mailbox" for each bot
  lengthQ=4 'length of "terminal" in and out qs
  retriesAdd=4 'number of times to retry adding a command
  retriesSend=3 'number of times to retry sending data
  timeoutSend=8_000_000 'cnts to wait before a send fails

  TXPIN=|<6  
  RXPIN=|<7
  RTSPIN=|<5
  #0,mAddCmd,mWrite,mSend,mReply,mReboot,mStopCogs,mStream,mTerm,mClear,mDbg 'message types
  xRX16=$81
  xTX16=$01
  xTXstatus=$89
  xStartByte=$7e 'indicates start of a packet
  {useless info:
  buffer for sending data out is 202 bytes long, cts is de-asserted when only 17 free
  use ap=2 when using escaped characters see pg57

  TODO:
  -test terminal 12blocks
  -test send 12blocks
  -test write 12blocks
  -use longs
  }
  i2cSCL        = 28
  i2cSDA        = 29 
  MCP23008_Addr = %0100_0000  
pub start(_cmdList,_cmdStatus,_mailbox,_info,_rssi,_sender2terminal,_sender2mail,_dptr)
  tcmdList:=_cmdList
  tcmdStatus:=_cmdStatus
  tmailbox:=_mailbox
  tinfo:=_info
  trssi:=_rssi
  dbgptr:=_dptr
  tsend2term:=_sender2terminal
  tsend2mail:=_sender2mail
  bytefill(tcmdList,0,maxCmds*4)  
  bytefill(tcmdStatus,0,maxCmds*4)
  bytefill(tmailbox,0,maxbots*lenMail)
  bytefill(tsend2term,0,maxbots)
  bytefill(tsend2mail,0,maxbots)
  txiMask:=$ffff_ffff-txMask
  rtsiMask:=$ffff_ffff-rtsMask
  bitticks:=clkfreq/115_200
  stoptickst:=bitticks*10
  stopticks:=bitticks*2
  ldelay:=clkfreq/10                  
  'broadcast  a stream message to all bots, starting w _info(item), length len  
  cognew(@pasmTX,0)
pub stream(sStart,strEnd)
  return addCmd(mstream,0,sStart<<2,(strEnd-sStart+1)<<2)
pub clearCmd(addr)
  {clears the command list on addr}
  return doCmdAck(addr,mClear,0,0)
pub addRemoteCmd(addr,raddr,rmode,rptr,rlen)|t
  {add a command on addr's command list}
  t:=rmode<<28+raddr<<24+rptr<<8+rlen
  return doCmdAck(addr,mAddCmd,@t,4)
pub startTerminal(addr,qptr)|cIdx
  {starts a terminal session with a bot}
  cIdx:=addCmd(mTerm,addr,qptr,0) 'adds a command to hande terminal data
  if cIdx==-1
    return false
  long[tcmdStatus][cidx]~   
  long[tsend2Term][addr]:=cIdx
  return cIdx
pub stopTerminal(cIdx)
  waitcnt(cnt+clkfreq/1)
  long[tcmdList][cIdx]~
  { input comes in at inhead.  output goes out at outhead
    - cmd    for cterminal is:[mode4   ,addr4  ,ptr16  ,outtail8]
    - status for cterminal is:[outhead8,intail8,inhead8,_       ]}
pub tx(t,tb)|cmd,outq,ptr,head
  {send a byte over emulated terminal and increment outhead}
  cmd:=long[tcmdList][t]
  ptr:=(cmd>>8) & $ffff
  head:=byte[tcmdStatus+(t<<2)+3]
  
  byte[ptr+head++]:=tb                      'add byte to outq  
  if head==lengthQ
    head~     
  repeat while head==byte[tcmdList+(t<<2)] 'wait while==outtail
  'waitcnt(cnt+clkfreq/10)
  byte[tcmdStatus+(t<<2)+3]:=head           'increment outhead
pub rxavailable(t)|cmd,ptr,head,tail
  {returns true if data available}
  cmd:=long[tcmdList][t]
  ptr:=(cmd>>8) & $ffff+lengthQ 'get ptr to inQ
  tail:=byte[tcmdStatus+(t<<2)+2]
  head:=byte[tcmdStatus+(t<<2)+1]
  return head<>tail
pub rx(t)|cmd,ptr,head,tail
  {waits until rxavailable, then returns a byte}
  repeat while not rxavailable(t)
  cmd:=long[tcmdList][t]   
  ptr:=(cmd>>8) & $ffff+lengthQ 'get ptr to inQ
  tail:=byte[tcmdStatus+(t<<2)+2]  
  result:=byte[ptr + tail]
  tail+=1
  if tail==lengthq
    tail~
  byte[tcmdStatus+t<<2+2]:=tail
pub gotMail(addr,nptr)
  {See if we've got mail from a bot
    addr:address of bot you'd like to check mail from
    returns address of received mail on success or false}
  if byte[tmailbox][lenMail*addr]
    bytemove(nptr,tmailbox+lenMail*addr,lenMail)
    return true
  return false
pub reply(addr,ptr)
  {Reply to a mail
  Return TRUE on success}
  byte[tmailbox+lenMail*addr]~  'clear first byte to indicate empty mailbox
  return doCmdAck(mReply,addr,ptr,lenMail)
pub send(addr,ptr,rptr)|cIdx,cntr,ts2m
  {Send "mail" to another bot.
    addr:address of bot to send to, 0 sends to all
    ptr:points to data to send
    rptr:points to area where reply will be stored
    Returns TRUE if successful}
  ts2m:=tsend2mail+addr 'store cidx into tsend2mail[addr] to only send 1 mail
  if byte[ts2m]==0
    repeat retriesSend
      cIdx:=addCmd(mSend,addr,ptr,lenMail)
      if cIdx> -1
        long[tcmdStatus][cIdx]:=rptr
        byte[ts2m]:=cIdx
        cntr:=cnt      
        repeat while cnt-cntr < timeoutSend
          if (long[tcmdStatus][cIdx] & |<31)      'high bit set indicates got reply
            long[tcmdList][cIdx]~
            byte[ts2m]~
            return true
        long[tcmdList][cIdx]~          
  byte[ts2m]~
  return false
'med level  
pub doCmdAck(mode,addr,ptr,len)|cIdx,cntr
  {Do command and wait for ack
  used by cStopCogs,cWrite,cReboot,cReply
  cStream doesn't care about ACK
  cSend waits for mReply
  returns TRUE on success}
   
  repeat retriesSend
    cIdx:=addCmd(mode,addr,ptr,len)
    long[tcmdStatus][cIdx]~
    cntr:=cnt
    repeat while cnt-cntr<timeoutSend
      if long[tcmdStatus][cIdx] & $B000_0000       '2 high bits indicates got ack
        long[tcmdList][cIdx]~
        return true
    long[tcmdList][cIdx]~        
  return false        
pub addCmd(mode,addr,ptr,len)|i
  {Add a command to the list.  Returns index of command, or -1 if none available after retrying.}
  repeat retriesAdd
    repeat i from 0 to maxCmds-1
      if long[tcmdList][i]==0  
        long[tcmdList][i]:=mode<<28+addr<<24+ptr<<8+len '16 modes, 16 addresses, 32kb offset, 256b length        
        return i
  return -1
  
'low level PASM driver code (spin for now)        
   
dat  
'prog long $d63d0337,$3d03371c,$7e041cd4
{ spin code for:
  dira[pin]~~
  outa[pin]~~
  repeat}   
  org 0
pasmTx              
          or      dira,txmask
          or      outa,txmask
          or      dira,rtsmask
          
 cmdLoop  mov   tIdxc,#MaxCmds 'repeat tidxc from maxcmds..1
 txLoop   call  #doRX
          tjnz  stopped,#txLoop  'when stopped not zero only receive
          djnz  t6,#txLoop
          mov   t6,#$1ff
          mov tIdx,tIdxc
          sub tIdx,#1 wz   'tidx goes from maxcmd-1..0
          mov   tIdx2,tIdx
          shl   tIdx2,#2    'tIdx2:=tidx<<2
          mov   t1,tIdx2
          add   t1,tcmdList
          rdlong tCmd,t1  'cmd:=cmdList[cIdx]
          cmp   tCmd,#2 wc 'c set if tcmd<2
  if_nc   call  #txCmd
          djnz  tIdxc,#txLoop      'repeat tidx
          jmp   #cmdLoop 
   txCmd                 
  'decompress cmd
          mov   tlen,tCmd   
          and   tlen,#255   'len:=cmd & 255
          mov   tptr,tCmd
          shr   tptr,#8
          and   tptr,tWord  'ptr:=(cmd>>8) & $ffff
          mov   taddr,tCmd
          shr   taddr,#24
          and   taddr,#15 wz   ' addr:=(cmd>>24) & $f
   if_z   mov   taddr,tword    'if addr=0, then broadcast,using taddr=tword       
          mov   tmode,tCmd                   
          shr   tmode,#28
          and   tmode,#15  wz 'mode:=(cmd>>28) & $f
          mov   toptions,#0 'options:=0 'by default packet will cause an ack to be sent and request complete status to appear
          mov   tframe,tIdxc 'frame:=cIdx+1 'when request complete arrives, frame is used to assign status          
          mov   twrap,#0  'send loop compares ptr++ to twrap, which is set by mTerm
  'Alter options/frame based on mode
  {if mode==mSend or mode==mStream
    'don't send auto-ack or status: force mail recipient to reply manually
    frame~
    options:=1
    if mode==mSend
      len+=1}
          cmp   tmode,#mSend wz 'z set if equal
  if_z    mov   tframe,#0
  if_z    mov   toptions,#1
  if_z    add   tlen,#1
          cmp   tmode,#mStream wz    
  if_z    mov   tframe,#0
  if_z    mov   toptions,#1
  if_z    add   tlen,#1  'len+=1
          cmp   tmode,#mTerm wz
  if_nz   jmp   #:notTerm        
  {elseif mode==mTerm   output from tail to head
    - cmd    for cterminal is:[mode4   ,addr4  ,ptr16  ,outtail8]
    - status for cterminal is:[outhead8,intail8,inhead8,_       ]}
          mov   tframe,#0    'frame~
          mov   toptions,#1  'options:=1    
          mov   ttail,tlen   'tail:=len  
          mov   twrap,tptr
          add   twrap,#lengthQ'    wrap:=ptr+lengthQ
          mov   thead,tIdx2
                    
          add   thead,#3         
          add   thead,tcmdStatus
          rdbyte thead,thead 'head:=byte[@cmdStatus+(cIdx<<2)+3]
          
         
          
          cmp   thead,ttail wz
   if_z   jmp   #txcmd_ret     'if head==tail      return
          mov   tlen,thead
          sub  tlen,ttail   wc 'len:=head-tail          
   if_c   add  tlen,#lengthQ 'if len<0  len+=lengthQ     
   
      
          add   tptr,ttail   'ptr+=tail 'ptr now points to next element in q to send
  :notTerm      
          
  'Build frame:start,len2,xTX16,frame,dest2,options,data,crc
          mov   tbyte,#xStartByte'  txByte(xStartByte) '7e
          call  #transmit
          call  #transmit '  txByte(0) 'len msb, always <256
          mov   tbyte,tlen
          add   tbyte,#6
          call  #transmit  '  txByte(len+6)
          mov   tcrc,#255 '  crc:=$ff   
          mov   tbyte,#xtx16
          call  #transmitcrc'  txByte(xTX16) '1-sent a 16bit packet
          mov   tbyte,tframe
          call  #transmitcrc '  txByte(frame) '1
          mov   tbyte,taddr
          shr   tbyte,#8
          call  #transmitcrc '  txByte(addr-HI) 
          mov   tbyte,taddr
          call  #transmitcrc'  txByte(addr)
          mov   tbyte,toptions
          call  #transmitcrc '  txByte(options)
  'Send data
          mov   tbyte,tmode
          call  #transmitcrc'    txByte(mode)
          cmp   tmode,#mdbg  wz '  if mode==mdbg
   if_z   mov   tbyte,tptr
   if_z   call  #transmitcrc   'send mid bytes of tcmd 
   if_z   call  #transmitcrc
   if_z   mov   tbyte,tcrc
   if_z   call  #transmit
   if_z   jmp   #txcmd_ret     
          cmp   tmode,#msend wz '  if mode==mSend
   if_z   mov   tbyte,tidx
   if_z   call  #transmitcrc '    txByte(cIdx)
   if_z   sub   tlen,#1'    len-=1
          cmp   tmode,#mstream wz '  if mode==mstream
   if_z   mov   tbyte,tptr
   if_z   call  #transmitcrc '    txByte(cIdx)
   if_z   add   tptr,tinfo  'tptr+=tifo
   if_z   sub   tlen,#1'    len-=1
          
          mov   t1,tlen 'repeat len
 :repLen  rdbyte tbyte,tptr 
          
          call  #transmitcrc 'txByte(byte[ptr])
          add   tptr,#1 'crc-=byte[ptr++]
          cmp   tptr,twrap wz
    if_z  sub   tptr,#lengthq 'if (mode==mTerm) and (ptr==wrap)   ptr-=lengthQ              
          djnz  t1,#:repLen
          mov   tbyte,tcrc
          call  #transmit
          mov   t1,tidx2          
          cmp   tmode,#mStream wz 'if mode==mStream   
   if_z   add   t1,tcmdstatus
   if_z   rdlong  t2,t1                    
   if_z   add   t2,#1
   if_z   wrlong  t2,t1'    cmdStatus[cIdx]++  'increment status as soon as data streamed
   if_z   jmp   #txcmd_ret
          cmp   tmode,#mTerm wz 'if mode==mTerm
   if_z   add   t1,tcmdlist
   if_z   wrbyte thead,t1'in terminal mode:byte[@cmdList+(cIdx<<2)]:=head 
   if_z   jmp   #txcmd_ret
          add   t1,tcmdList
          mov   t2,#1
          wrlong t2,t1 'cmdList[cIdx]:=1  'set to 1 to indicate message sent, waiting for ack
txcmd_ret ret                 
'********rx
'Receive data from device:start,len2,x81,source2,rssi,options,data

dorx        
          and     outa,rtsimask  'lower rts
          mov     rxcnt,stopticks
          add     rxcnt,cnt    'start rxcnt with stopticks
          mov     t1,#0    't1 counts how many bytes received
          'don't transmit in receive section, tbyte and count of bytes will be sent at end
          call    #rxByte 'try to receive a startbyte
          cmp     rxData,#xstartByte wz 'if rx<>startbyte stop rx
   if_z   jmp     #hStart
   rxend  or      outa,rtsmask    'raise, turn rts off- at end of packet go here
          call    #rxByte 'may receive one more byte
          cmp     rxData,#xstartByte wz 'if rx<>startbyte
   if_nz  jmp     #dorx_ret  'leave routine with rts off, no start byte      
          and     outa,rtsimask  'if got a start byte, lower rts to restart receiving
          add     rxcnt,stopticks 'give more time 
   hStart call    #rxByte  'len msb, always <256, so ignore 
          call    #rxByte
          mov     tlen,rxData
          sub     tlen,#6 '  length:=rxByte-6    
          call    #rxByte
          cmp     rxData,#xTXstatus wz
    
    if_nz jmp     #:notStat ' case rxByte type of xbee message
    '
 '   xTXstatus:  got a transmit request complete for a command we issued        
          call    #rxByte
          mov     tFrame,rxData
          sub     tFrame,#1 'frame:=rxbyte-1                 'get the frame, this tell us which cIdx this is associated with
          mov     t2,tFrame
          shl     t2,#2
          add     t2,tcmdStatus
          add     t2,#3
          rdbyte  t3,t2  't3=cmdStatus[frame][3]
          call    #rxByte
          cmp     rxData,#0 wz   'if rxbyte==0  status of 0 indicates success
   if_z   or      t3,#64  'cmdStatus[frame]|= |<30       'write success
          or      t3,#128 'cmdStatus[frame]|= |<31         'indicate got status back
          tjnz    stopped,#:skipw 
          wrbyte  t3,t2           
:skipw    jmp     #rxend'
  
 :notStat
             
          cmp     rxData,#xRX16 wz   
  if_nz   jmp     #rxend        
    'xRX16:  '81 got a 16bit message

          call    #rxByte'      rxByte sender msb, always <256, so ignore      
          call    #rxByte
          
          mov     tSender,rxData 'sender:=rxByte get message sender
          mov     t2,trssi
          add     t2,tSender
          call    #rxByte
          tjnz    stopped,#:norssi
          wrbyte  rxData,t2'  rssi[sender]:=rxByte store latest signal for that sender
 :norssi  call    #rxByte '      rxByte                          'ignore options      
          call    #rxByte     
          mov     tMode,rxData
          add     rxData,#:domode
          nop

          jmp     rxData
          
:domode   jmp     #rAddCmd
          jmp     #rWrite
          jmp     #rSend
          jmp     #rReply
          jmp     #rReboot
          jmp     #rStopCogs
          jmp     #rStream
          jmp     #rTerm
          jmp     #rClear
          jmp     #rDbg
          '7e 00 06 81 22 00 10 00 09 for rr
  rr      mov   tbyte,tMode
          jmp   #rxend
  rDbg    
          mov   t3,thirty2k
          mov   tcmd,#0
  :crc    rdbyte t2,t3
          add   tcmd,t2
          djnz  t3,#:crc
          and   tcmd,#255  'tcmd=crc
          shl   tcmd,#8
          shl   tsender,#24
          add   tcmd,tsender
          add   tcmd,dbgEcho
          call  #txCmd
          jmp   #rxend
  rClear  mov   t2,#MaxCmds
          mov   t3,tcmdList
          mov   t4,#0          
  :clear  wrlong  t4,t3  'fixed, was writing to 0
          add   t3,#4
          djnz  t2,#:clear
          jmp   #rxend  
          '7e 00 06 81 00 00 10 00 09 for rr
 rTerm          
            '7 got terminal data,  input at head            
    '- cmd    for cterminal is:[mode4   ,addr4  ,ptr16  ,outtail8]
    '- status for cterminal is:[outhead8,intail8,inhead8,_       ]
       '7e 00 07 81 22 00 10 00 07 65 sends an "a"
          add   tsender,tsend2term
          rdbyte  tsender,tsender 
          shl   tsender,#2 'tsender=sender2Terminal[sender]<<2
          
          mov   tptr,tsender
          add   tptr,tcmdList
          rdlong tptr,tptr
          shr   tptr,#8
          and   tptr,tword
          add   tptr,#lengthQ'ptr:=(cmdList[tsender] >>8) & $ffff_ffff + lengthQ 'get inQ
          mov   t2,tsender
          
          add   t2,#1
          add   t2,tcmdStatus
          rdbyte t2,t2
          add   t2,tptr 't2:=ptr+byte[@cmdStatus+tsender<<2+1] 'i=inq[head]
          mov   t3,tptr '
          add   t3,#lengthQ 't3:=ptr+lengthq
  :rep    call  #rxbyte 'repeat length  
          wrbyte  rxdata,t2
          add   t2,#1 'byte[i++]:=rxbyte
          cmp   t2,t3 wz 'if i==ptr+lengthQ
     if_z mov   t2,tptr'i:=ptr                  'reset circular q
          djnz  tlen,#:rep
          add   tsender,#1
          add   tsender,tcmdStatus
          sub   t2,tptr
          wrbyte  t2,tsender'  byte[@cmdStatus+tsender<<2+1]:=i-ptr 'set new head                    
          mov   tbyte,t2
          jmp   #rxend
  rAddCmd call  #rxLong  't5=rxByte<<24+rxByte<<16+rxByte<<8+rxByte        
          mov   t2,#maxCmds
          mov   t3,tcmdList
   :addc  rdlong tCmd,t3 wz 'if not cmdList[i]
    if_z  wrlong t5,t3 'cmdList[i]:=t4
          add   t3,#4
    if_nz djnz  t2,#rAddCmd 'repeat i from 0 to MaxCmds-1        
          jmp   #rxend
  rReboot cogid t3
          coginit interpreter  'start cog 0 with interpreter                             
   :stp   cogstop t3
          jmp   #rxend
rStopCogs
          cogid t3
          mov   t1,#0
          mov   t2,#8   't2 goes from 8..1, t1 from 0..7'Stop all COGs except this one 
   :reb   cmp   t1,t3 wz  'if cogid<>i
   if_nz  cogstop t1   'stop other than xconduit cog
          lockclr t1 
          lockret t1
          add   t1,#1   
          djnz  t2,#:reb   
          mov   t3,thirty2k
  :clearm wrbyte t2,t3 'clear mem
          djnz  t3,#:clearm
          mov   stopped,#1  'used to ignore hub memory           
          jmp   #rxend
   rWrite call  #rxByte '     'got request to write data to hub, ack sent automatically
          mov   tptr,rxData
          shl   tptr,#8
          call  #rxByte
          add   tptr,rxData'ptr:=rxByte<<8+rxByte 'will write to hub with offset
          sub   tlen,#2'          length-=2
:wData    call  #rxByte       
          wrbyte rxData,tptr' byte[ptr++]:=rxByte
          add   tptr,#1
          djnz  tlen,#:wData
          jmp   #rxEnd       
  rSend   mov   tptr,tMailbox
          mov   t2,tSender wz   'got Mail from other bot 
:mm if_nz add   tptr,#lenMail
          djnz  t2,#:mm '  ptr:=@mailbox+sender*lenMail 'will write message to mailbox for sender, will need to reply
          call  #rxByte
          wrbyte rxData,tptr 'byte[ptr++]:=rxByte         'read frame into first byte of mailbox
          sub   tlen,#1'          length-=1
          jmp   #rData
  rReply  add   tSender,tSend2Mail 'look up cidx using sender
          rdbyte rxData,tSender 'rxdata:=tsend2mail[tSender]
          shl   rxData,#2 
          add   rxData,tcmdStatus
          mov   tframe,rxData 'used to set high bits when finished receiving reply
          rdlong tptr,rxData  'ptr:=cmdStatus[frame]   'will write to mail reply buffer
          sub   tlen,#1'        length-=1          
          jmp   #rData
  rStream
          mov   tptr,tInfo 'got a Stream from bot
          call  #rxByte  'get offset
          add   tptr,rxData   'tptr:=tinfo+rxbyte
          sub   tlen,#1   'length-=1
rData     call  #rxByte
          tjnz  stopped,#:nowr
          wrbyte rxData,tptr' byte[ptr++]:=rxByte
:nowr     add   tptr,#1
          djnz  tlen,#rData'repeat length                 'write messsage data to ptr, can be in hub, mailbox, or reply buffer
          cmp   tmode,#mReply wz
  if_z    wrlong highbit,tframe 'write high bits to indicate got reply
          
          'If RTS is enabled for flow control (D6 (DIO6 Configuration)
'Parameter = 1), data will not be sent out the DO Buffer as long as RTS (pin 16) is de-asserted.
'data not sent as long as rts is low
          jmp   #rxend  'done receiving this packet 
dorx_ret  ret          
'******************* read an int into t4
  rxLong  mov     t4,#0
          mov     t5,#4
 :loop    call    #rxByte
          add     t4,rxData
          shl     t4,#8
          djnz    t5,#:loop
rxLong_ret ret        
'******************* read a byte into rxdata.  if none found, goes to startnotmatched
rxbyte 'read one byte               
 wstart   test    rxmask,ina      wc
if_nc     jmp     #gotStart
          mov     t0,rxcnt
          sub     t0,cnt wc          
   if_nc  jmp     #wstart     'wait for 1 bit somewhere in period
          mov     rxdata,#0
          jmp     #rxbyte_ret     'force end
gotstart  mov     rxcnt,cnt  'found trigger
          mov     t0,bitticks
          shr     t0,#1    
          add     rxcnt,t0  'add 1/2 bit to trigger to sample in mid
          mov     rxbits,#9             'ready to receive byte
:bit      waitcnt rxcnt,bitticks        'ready next bit period
          test    rxmask,ina      wc    'receive bit on rx pin
          rcr     rxdata,#1
          djnz    rxbits,#:bit      
          shr     rxdata,#32-8 
          waitcnt rxcnt,stopticks
          'add     rxcnt,stopticks
          'add     rxcnt,bitticks  'wait up to stopticks between bytes
          'waitcnt rxcnt,bitticks
          add     t1,#1
rxbyte_ret ret
rxbits long 0
rxcnt long 0
rxdata long 0

    
'************ send out tbyte and dec crc
transmitcrc
          sub  tcrc,tbyte  
          call #transmit
transmitcrc_ret ret
'************ send out tbyte, leaving it 0
transmit                                                
                        
                        mov     txcnt,bitticks
                        add     txcnt,cnt
                        and     outa,tximask  'send start for 1 bit  
                        mov     t0,#8
:bit                                                       
                        shr     tByte,#1       wc 
                        waitcnt txcnt,bitticks     
                        muxc    outa,txmask   'send 8 bits
                        djnz    t0,#:bit
                        waitcnt txcnt,stoptickst  'wait for last bit
                        or      outa,txmask   
                        'waitcnt txcnt,hsec 'wait 2 stopbits
                        waitcnt txcnt,#0
           transmit_ret ret   
                        
                  
                        
dbgEcho                 long  mDbg<<28|0<<24|2 'cmd, addr, ptr, len                     
tidxc                 long 0
thirty2k                long 32767   
hsec                    long    8_000_000                        
asec                    long    800_000  
ldelay long $1000_0000
rxmask                  long    RXPIN
txmask                  long    TXPIN
rtsmask                long    RTSPIN
rtsimask                long   0
bitticks                long    0
stopticks               long    0
stoptickst              long    0
tximask                 long    0
mcmd               long 0'mstream<<28|1<<24|0<<8|12
txcnt                 long    0
tbyte                 long    0    
tIdx2                 long    0
trssi                 long    0
tinfo                 long    0
myinfo                long    0
tmailbox              long    0
tcmdlist                 long    0
tsend2term          long 0
tsend2mail              long 0
tcmdstatus                 long    0
tcmd                 long    0
tmode                 long    0
taddr                 long    0
tptr                 long    0
tsender            long 0
tframe                 long    0
tlen                 long    0
tcrc                 long    0
toptions                 long    0
thead                 long    0
ttail                 long    0
twrap                 long    0
tidx                 long    0
tword                 long     $ffff
dbgptr                  long 0
interpreter             long    ($0001 << 18) | ($F004 << 2) | %0000
highbit                 long $f000_0000
stopped                 long 0
t6 long 100
t0 res 1
t1 res 1
t2 res 1
t3 res 1
t4 res 1
t5 res 1
t7 res 1