#include "Arduino.h"
#include "VPSerial.h"

#define termq 16//queue for sending out terminal data
#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif
typedef struct {
  int txcfg,rxptr;  
  byte state,encode,tmp,oddb,odds,txtail,txhead;
  byte txbuff[termq];
  byte mode;
}VpStr;
byte _vpc1[]={1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,5};
int vpStr_txbeg=385,vpStr_txend=387,vpStr_txnow=387;
VpStr vpStr;

#if defined(__AVR_ATmega2560__)
ISR(USART0_UDRE_vect) { 
#elif defined (__AVR_ATmega32U4__) // Use serial1 for ATmega32U4 (Teensy/Leonardo).    
ISR(USART1_UDRE_vect) { 
#else
ISR(USART_UDRE_vect) { 
#endif
 _vp.sendISR();
}

#if defined(__AVR_ATmega2560__)
ISR(USART0_RX_vect) { 
#elif defined (__AVR_ATmega32U4__) // Use serial1 for ATmega32U4 (Teensy/Leonardo).    
ISR(USART1_UDRE_vect) { 
#else
ISR(USART_RX_vect) { 
#endif
  _vp.receiveISR();
}

void _VPSerial::set(volatile uint8_t *ubrrh, volatile uint8_t *ubrrl,
  volatile uint8_t *ucsra, volatile uint8_t *ucsrb,
  volatile uint8_t *ucsrc, volatile uint8_t *udr,
  uint8_t rxen, uint8_t txen, uint8_t rxcie, uint8_t udrie, uint8_t u2x)
{
  _ubrrh = ubrrh;
  _ubrrl = ubrrl;
  _ucsra = ucsra;
  _ucsrb = ucsrb;
  _ucsrc = ucsrc;
  _udr = udr;
  _rxen = rxen;
  _txen = txen;
  _rxcie = rxcie;
  _udrie = udrie;
  _u2x = u2x;
}
void _VPSerial::init(int baud){  
//see v1.04 hardwareserial.cpp for how to set baud rate correctly
  
  //cli();
#if defined (__AVR_ATmega32U4__) // Use serial1 for ATmega32U4 (Teensy/Leonardo).    
  set(&UBRR1H, &UBRR1L, &UCSR1A, &UCSR1B, &UCSR1C, &UDR1, RXEN1, TXEN1, RXCIE1, UDRIE1, U2X1);
#else
  set(&UBRR0H, &UBRR0L, &UCSR0A, &UCSR0B, &UCSR0C, &UDR0, RXEN0, TXEN0, RXCIE0, UDRIE0, U2X0);
#endif
  vpStr.mode=0;  
  vpStr.txtail=0;
  vpStr.txhead=0;
  vpStr.txcfg=0;
  uint16_t baud_setting;
  bool use_u2x = true;

  if(baud>0) {
#if F_CPU == 16000000UL
  // hardcoded exception for compatibility with the bootloader shipped
  // with the Duemilanove and previous boards and the firmware on the 8U2
  // on the Uno and Mega 2560.
  if (baud == 57600) {
    use_u2x = false;
  }
#endif

try_again:
  if (use_u2x) {
    *_ucsra = 1 << _u2x;
    baud_setting = (F_CPU / 4 / baud - 1) / 2;
  } else {
    *_ucsra = 0;
    baud_setting = (F_CPU / 8 / baud - 1) / 2;
  }
  
  if ((baud_setting > 4095) && use_u2x)
  {
    use_u2x = false;
    goto try_again;
  }

  // assign the baud_setting, a.k.a. ubbr (USART Baud Rate Register)
  *_ubrrh = baud_setting >> 8;
  *_ubrrl = baud_setting;

  
  sbi(*_ucsrb, _rxen);
  sbi(*_ucsrb, _txen);
  sbi(*_ucsrb, _rxcie);
  sbi(*_ucsrb, _udrie); //was cbi
 
  
  /* old way, doesn't work for some:int baud_prescaler= (((F_CPU / (baud * 16UL))) - 1);
  UBRR0H = (uint8_t)(baud_prescaler>>8);
  UBRR0L = (uint8_t)(baud_prescaler);
   
  UCSR0B = (1<<RXEN0)|(1<<TXEN0)|(1<<RXCIE0)|(1<<UDRIE0);//use tx/rx pins for uart, turn on interrupts

  UCSR0C = ((1<<UCSZ00)|(1<<UCSZ01));  //8ni
  */
    } //baud>0	
	sei();
  
  delay(100); //wait until everything is ready
  *_udr=5; //hh
}

 /*called when got a byte.  
    1=*(1,2)=3
	4=*(4,5)=6,7
	8=restart tx-8
	9=pause all
	10=resume
	*/	
  int t; 
void _VPSerial::receiveISR() {
  switch(vpStr.state) {
  case 0:vpStr.state=*_udr;return; //dd
  case 4:
  case 1:vpStr.rxptr=*_udr;vpStr.state++;return;
  case 5:
  case 2:vpStr.rxptr=(vpStr.rxptr<<8)+*_udr;vpStr.state++;return;
  case 3:*((byte*)vpStr.rxptr)=*_udr;vpStr.state=0;break;
  case 6:vpStr.tmp=*_udr;vpStr.state++;return;
  case 7:*((int*)vpStr.rxptr)=(vpStr.tmp<<8)+*_udr;break;
  case 8:vpStr_txnow=vpStr_txbeg;vpStr.odds=false;t=*_udr;break;
  case 9: vpStr.txcfg=(int)&_vpc1;t=*_udr;break;
  //case 10:xTaskResumeAll();t=_udr;break;
  }
  vpStr.state=0;
}
void _VPSerial::sendISR() {
//called when need to send next byte.  will always send 85-15-(packet with 85 encoded as 85-16)
	byte nb;
	if(vpStr.encode) {
		*_udr=16;
		vpStr.encode=false;	
		return;
	}
	switch(vpStr.mode){
	case 1:  //send next terminaldata
	  nb=vpStr.txbuff[vpStr.txtail];  //tail points to byte to send
	  if(nb==85)
	    vpStr.encode=true;
	  *_udr=nb;
	  vpStr.txtail=(vpStr.txtail+1)%termq;
	  if(vpStr.txtail==vpStr.txhead)  //when tail catchs head, switch back to packet mode
	    vpStr.mode=0;
	  break;
	case 2: //send config	
	  nb=*((byte *)vpStr.txcfg);
	  if(nb==85)
	    vpStr.encode=true;
	  *_udr=nb;
	  vpStr.txcfg++;
	  if((int *)vpStr.txcfg==&vpStr_txnow){
		vpStr.mode=0;
		vpStr.txcfg=0;
	  }
	  break;
	case 0:   //packet mode
		switch(vpStr_txnow-vpStr_txend) {
		case 0:
		  *_udr=85; //send out of band marker
		  vpStr_txnow++;
		  return;
		case 1:
		  if(vpStr.txcfg>0) {
		    vpStr.mode=2;
			*_udr=13; //start terminalout
			vpStr_txnow--; //start sending out 85 when exit terminal mode
		  }
		  else if(vpStr.txtail != vpStr.txhead) {
			vpStr.mode=1;
			*_udr=14; //start terminalout
			vpStr_txnow--; //start sending out 85 when exit terminal mode
		  }
		  else {
			vpStr_txnow=vpStr_txbeg;
			*_udr=15;  //start packet
			vpStr.odds=false;
		  }
		  return;
		default:
		  byte nb;
		  if(vpStr.odds) {
		    nb=vpStr.oddb;
			*_udr=nb;
		  }
		  else {
			nb=*((byte *)vpStr_txnow);
			vpStr.oddb=*((byte *)(vpStr_txnow+1));
			*_udr=nb;
		  }
		  vpStr.odds=not vpStr.odds;
		  if(nb==85) {  //if byte=85 then encode it so it's out of band
			vpStr.encode=true;		
		  }
		  vpStr_txnow++;		   
		}
	}
}

int _VPTerm::available(void)
{
   return 0;
}
void _VPTerm::str(String s){
	for(int n=0;n<s.length();n++) 
		write(s.charAt(n));
}
void _VPTerm::str(char* StringPtr){
  while(*StringPtr != 0x00){    //Here we check if there is still more chars to send, this is done checking the actual char and see if it is different from the null char
    write(*StringPtr);    //Using the simple send function we send one char at a time
    StringPtr++;}        //We increment the pointer so we can read the next char
}
int _VPTerm::peek(void)
{
  return 0;
}

void _VPTerm::write(char b) //nxt=txhead+1, delay if nxt=txtail, buff[head]=b
{
	byte nxt=(vpStr.txhead+1)%termq;	
	while(nxt==vpStr.txtail) {
		delay(10);
	}
	vpStr.txbuff[vpStr.txhead]=b;
	vpStr.txhead=nxt;
}
void _VPTerm::dec(int x){
	if(x<0) {
		write(45); //-
		x=-x;
	}
	bool lead=false;
	int res;
	for(int d=10000;d>0;d/=10) {
		res=x/d;
		if(res>0 && not lead) 
			lead=true;
		if(lead || d==1) 
			write(res+48);
		x-=res*d;
	}
}
void _VPTerm::strnum(String s,int x){
	write(11);
	str(s);
	col(2);
	dec(x);
	col(1);
}
void _VPTerm::strnum(char* StringPtr,int x){
	write(11);
	str(StringPtr);
	col(2);
	dec(x);
	col(1);	
}

void _VPTerm::pos(int x,int y){
	write(2);write(x);write(y);
}
void _VPTerm::col(int c){
	write(17);write(c);
}
int _VPTerm::read(void)
{
return 0;
}

void _VPTerm::flush()
{
}
