#include <arduino.h>
#include "or_bug.h"
//for tbug
#define SPI_MODE_MASK 0x0C  // CPOL = bit 3, CPHA = bit 2 on SPCR
#define SPI_CLOCK_MASK 0x03  // SPR1 = bit 1, SPR0 = bit 0 on SPCR
#define SPI_2XCLOCK_MASK 0x01  // SPI2X = bit 0 on SPSR
#define SPI_CLOCK_DIV2 0x04

void _OR_bug::begin() {
	unsigned char n;	
	for(n=0;n<_SERVOS;n++) {_servo_pos[n]=255;_servo_targ[n]=255;}
	for(n=8;n<11;n++) digitalWrite(n,LOW);	
	_latch=7; //will get ++
	_count=255;	//causes immediated calculation of events	
	//init spdr
	digitalWrite(SCK, LOW);
	digitalWrite(MOSI, LOW);
	digitalWrite(SS, HIGH);
	SPCR |= _BV(MSTR);
	SPCR |= _BV(SPE);
	int rate=SPI_CLOCK_DIV2 ;
	SPCR = (SPCR & ~SPI_CLOCK_MASK) | (rate & SPI_CLOCK_MASK);
	SPSR = (SPSR & ~SPI_2XCLOCK_MASK) | ((rate >> 2) & SPI_2XCLOCK_MASK);
}
void _OR_bug::doout(unsigned char output) {
  SPDR = output; // push the byte to be loaded to the SPI register
  while(!(SPSR & (1<<SPIF))); //wait till the register completes
  digitalWrite(_latch,LOW);
  digitalWrite(_latch,HIGH);
}
void _OR_bug::isr(){
  unsigned char output,n,min,idx;      
  _count++;
  if(_count==255) { //calculate next group, count is now 0
    if(++_latch==11) _latch=8; //next latch
	_latchport=portOutputRegister(digitalPinToPort(_latch));
	_latchmask=digitalPinToBitMask(_latch);	
		
		//calculate events
		for(n=0;n<8;n++) _tmp[n]=_servo_pos[(_latch-8)*8+n]; //gets servo values for latch
		output=255; //start states as high, lower for each servo
		//
		
		for(_event=0;_event<_EVENTS;_event++) {
			min=_tmp[0];idx=0; //find least one
			for(n=1;n<8;n++)
				if(_tmp[n]<min) {min=_tmp[n];idx=n;}
			if(min==255) break;  //when minimum is 255 stop adding events
			if(_event>0 && _servo_cnt[_event-1]==min) _event--; //collapse events with same time
			_servo_cnt[_event]=min;
			//output &= ~(1<<idx); //finish servo's pulse '32107654
			output &= ~(1<<((11-idx)%8)); //finish servo's pulse
			_servo_out[_event]=output;
			_tmp[idx]=255; //don't process this servo again
		}
		_servo_cnt[_event]=255;	//last event is 255	
		output=255;//now finish by outputting start state	
	_event=0; //now set to first event
	doout(output);
  }
  else if(_count==_servo_cnt[_event]) {
    doout(_servo_out[_event++]); //get pin states to output   	
  }    
  switch(doping) {
		case 1: //send trigger
			digitalWrite(A3,0);		
			pinMode(A3,INPUT);
			doping++;
			count=0;
		case 2: //wait for high
			if(digitalRead(A5) || count++>200) {
				doping++;
				count=0;
			}
			break;
		case 3: //wait for low or timeout then store ping, and reset doping
			if(!digitalRead(A5) || count++>200) {
				doping=0;
				ping=count;
			}			
   }
  //*_latchport &= ~_latchmask; // set register
  //*_latchport |= _latchmask;  // 
}
void _OR_bug::servo(int which,int amt) {
	_servo_pos[which]=amt;
}
void _OR_bug::target(int which,int how,int amt) {
	for(char n=0;n<6;n++) { //go through legs 0..5
		if(which & (1 << n)) {  //if bit set act on it			
			if(amt==255) 
			switch(how) {  //_servo values 255
				case 0 : _servo_targ[n*4+0] = 255;break;				
				case 1 : _servo_targ[n*4+1] = 255; break; //hip  0..100
				case 2 : _servo_targ[n*4+2] = 255; break; //knee 0..100
				case 3 : _servo_targ[n*4+1] = 255;_servo_targ[n*4+2] = 255; break; //height 0..100
			}
			else
			switch(how) {  //_servo values are 78=1msec, 117=1.5msec, 156=2msec
				case 0 : 
				if(n<3)
					_servo_targ[n*4+0] = 78+amt;  //angle -30..30
				else
					_servo_targ[n*4+0] = 106-amt;  //angle -30..30
				break;
				
				case 1 : _servo_targ[n*4+1] = 38+amt; break; //hip  0..100
				case 2 : _servo_targ[n*4+2] = 56+amt; break; //knee 0..100
				case 3 : _servo_targ[n*4+1] = 38+amt;_servo_targ[n*4+2] = 86+amt; break; //height 0..100
			}
		}
	}
}
void _OR_bug::achieve(int wt) {
	unsigned int n,tmp[_SERVOS],fract,ifract;
	unsigned int m;		
	if(wt>100) {	
		for(n=0;n<_SERVOS;n++) 
			if(_servo_pos[n]==255)
				tmp[n]=_servo_targ[n];
			else
				tmp[n]=_servo_pos[n]; //copy current position	
		for(m=0;m<wt;m+=10){  //adjust through time			
			fract = m/ (wt/100); //0..100. ok when wt>100
			ifract = 100 - fract; //100..0
			for(n=0;n<_SERVOS;n++) 
				_servo_pos[n]=((tmp[n]*ifract)+(fract*_servo_targ[n]))/100;					
			pauset(10);				
		}
	}
	else
		pauset(wt);
	for(n=0;n<_SERVOS;n++) _servo_pos[n]=_servo_targ[n]; 
	
}
int _OR_bug::sense(char x) {
//0-2:line,3-ping,4-button,5-bat,6-mic
	int m;
	switch(x) {
		case 2: //force on A2
			return analogRead(A2);
		case 3: //ping done by isr
			if(!doping) 
				doping=1;
			return ping;			
		case 4: //buttons are on A3.  1023=up, 619=1, 841=2, 546=both
			m=analogRead(A3);
			if(m>1000)
				return 0;
			else if(m>800)
				return 1;
			else if(m>600)
				return 2;
			return 3;		
		case 5: //bat on A7. 488=ok
			return analogRead(A7);
		case 6: //mic on A6. 0=512
			return analogRead(A6)-512;
	}		
}
