#include <arduino.h>
#include "or_tbot.h"
void _highpin(uint8_t pin,uint8_t mode){
	uint8_t bit = digitalPinToBitMask(pin);
	uint8_t port = digitalPinToPort(pin);
	volatile uint8_t *out,*reg;
	
	out = portOutputRegister(port);
	reg = portModeRegister(port);
		
	switch(mode){
	case 1:
		*reg |= bit; //set output
		*out |= bit; //set high
		*reg &= ~bit; //set input
		break;
	case 2:	
		*reg |= bit; //set output
		*out &= ~bit; //set low
		break;
	case 3:
		*reg &= ~bit; //set input
	}
	
}
void _OR_tbot::isr() {// isr=12.8us
	unsigned char n;
	
	switch(doline) {	
		case 4000: //do line 20hz=50msec, charge ir's for 21*12us			
			for(n=A0;n<A3;n++){				
				_highpin(n,1);				
			}		
			doline=0;
			break;
		case 3000: // read ir's, set up ping
			for(n=A0;n<A3;n++) {
				line[n-A0]=analogRead(n);
			}	
			break;						
	}
	doline++;
	switch(doping) {  //0=idle
		case 1: //send trigger
			_highpin(A3,2);
			doping++;
			count=0;
		case 2:
			_highpin(A3,3);
			doping++;
		case 3: //wait for high
			if(digitalRead(A5)||count++>200) {
				doping++;
				count=0;
			}
			break;
		case 4: //wait for low or timeout then store ping, and reset doping
			if(!digitalRead(A5) || count++>200) {
				doping=0;
				
				if(count>ping1)  //out of 4, take 3rd highest
					if(ping2>ping3)
						ping=(count<ping2?count:ping2); //lowest of count,ping2
					else
						ping=(count<ping3?count:ping3); //lowest of count,ping3
				else
					if(ping2>ping3)
						ping=(ping1<ping2?ping1:ping2); //lowest of ping1,ping2
					else
						ping=(ping1<ping3?ping1:ping3); //lowest of ping1,ping3
				ping3=ping2; //3 latest pings
				ping2=ping1;
				ping1=count;			
			}			
	}
}
int _OR_tbot::sense(char x) {
//0-2:line,3-ping,4-button,5-bat,6-mic
	int m;
	switch(x) {
		case 0: //line continually tested by isr
		case 1:
		case 2:			
			return line[2-x];
		case 3: //ping done by isr
			if(!doping) doping=1;
			return ping;			
		case 4: //buttons are on A3.  1023=up, 619=1, 841=2, 546=both
			m=analogRead(A3);			
			if(m>1000)
				return 0;
			else if(m>800)
				return 1;
			else if(m>600)
				return 2;
			return 3;		
		case 5: //bat on A7. 488=ok
			return analogRead(A7);
		case 6: //mic on A6. 0=512
			return analogRead(A6)-512;
	}		
}
